from fuzzywuzzy import fuzz, process


def prep_list(filename):
    result = []
    with open(filename, "r") as raw:
        text = raw.read()
    item = ""
    sent_cut = ".:;?!"
    for char in text:
        if char != "\n" and char not in sent_cut:
            item += char
        else:
            if char in sent_cut:
                item += char
            result.append(item.strip())
            item = ""
    return [item for item in result if item != ""]


def find_best_match(sent, set_colors):
    best_match = process.extractOne(sent, set_colors)
    index = set_colors.index(best_match[0])
    # Find the next available index
    while index in used_indices:
        index = (index + 1) % len(set_colors)
    # IGNORE "9010 Reinweiß"
    # while index in used_indices or "9010" in set_colors[index]:
    #     index = (index + 1) % len(set_colors)
    used_indices.add(index)
    return set_colors[index]


# READ FILE INTO LIST
sents = prep_list("files/10 Auswahl 5 Form.txt")
colors = prep_list("files/ral.txt")

# Iterate over sentences in set1 and find the best match from set2
used_indices = set()  # Track the indices of matched strings from set2

display_list = []
for sentence in sents:
    best_match = find_best_match(sentence, colors)
    display_list.append((sentence, best_match, len(sentence)))
for tuple in sorted(display_list, key=lambda tuple: tuple[2], reverse=True):
    print(f"{tuple[0]}\n{tuple[1]} / {len(tuple[0])} \n")
